#!/usr/bin/perl
# $Id: rottentomatoes.t 3739 2010-01-19 12:29:21Z chris $

use strict;
use warnings;

my @tests = (
    sub {
	use WebService::RottenTomatoes;

	my $w = WebService::RottenTomatoes->new() or die;
	my $m = $w->search('type' => "Movie", 'rtid' => "1100025") or die;

	die unless ($m->rtname() eq "almost_famous");

    },

    sub {
	use WebService::RottenTomatoes;

	my $w = WebService::RottenTomatoes->new() or die;
	my $m = $w->search('type' => "Movie", 'imdbid' => "tt0181875") or die;

	die unless ($m->rtname() eq "almost_famous");

    },

    sub {
	use WebService::RottenTomatoes;

	my $w = WebService::RottenTomatoes->new() or die;
	my $m = $w->search('type' => "Movie", 'imdbtitle' => "Almost Famous (2000)") or die;

	die unless ($m->rtname() eq "almost_famous");

    },

    sub {
	use WebService::RottenTomatoes;

	my $w = WebService::RottenTomatoes->new() or die;
	my $m = $w->search('type' => "Movie", 'rtname' => "goldfinger") or die;

 	die unless ($m->tmeter_critics_score());
	die unless (check_score($m->tmeter_critics_score()));
	die unless (check_score($m->top_critics_score()));
	die unless (check_score($m->_rt_community_score()));
	die unless (check_score($m->_my_critics_scores()));
	die unless (check_score($m->_my_friends_score()));
	die unless (check_score($m->_dvd_score()));

	die unless (check_score_details($m->tmeter_critics_details()));

    }, 

    );

printf "%d..%d\n", 1, scalar @tests;

foreach (@tests) {

    eval { &$_(); };

    if ($@) {
	print "not ok\n";
    } else {
	print "ok\n";
    }
}


sub check_score {
    my $score = shift;
    die unless (!defined $score || $score >= 0 && $score <=100);
}

sub check_score_details {
    my $details = shift;
    die unless (defined $details->{'total'} && $details->{'total'} > 0);
    die unless (defined $details->{'fresh'} && $details->{'fresh'} > 0);
    die unless (defined $details->{'rotten'} && $details->{'rotten'} > 0);
    die unless (defined $details->{'average'} && ref $details->{'average'} eq "ARRAY");
    die unless ($details->{'average'}->[0] >= 0 && $details->{'average'}->[0] <= $details->{'average'}->[1]);
}
